<?php
/*
 * LMS version 1.11.3 Quetesh
 *
 *  (C) Copyright 2001-2008 LMS Developers
 *
 *  Please, see the doc/AUTHORS for more information about authors!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 *
 */
global $DB;
global $mv;
global $cp;
global $rm;
$mv = "/bin/mv";
$cp = "/bin/cp";
$rm = "/bin/rm -f";
function background_find() //znajdz pliki do umieszczenia w select, pomin te z timestampem
{
global $pliki;
foreach(new DirectoryIterator(getcwd().'/img/map/') as $plik)
        {
        IF(!$plik->isDot())
                {
                IF(preg_match('/^.+\.(jpg|JPG)$/D', $plik) && !preg_match('/^.+(timestamp).+$/D', $plik))
			{
			$pliki[] = $plik->getFilename();
			}
                }
        }
}

function draw_nodes($imgname, $save) //rysowanie wezlow na mapie
{
global $DB;
global $CONFIG;
$checkbg = '"'.$_GET['tlo'].'"';
$asd = $_GET['tlo'];
$im = @imagecreatefromjpeg($imgname);
if(!$im)
	{
        echo "Unable to open an image!";
        }
$dupa = $DB->GetAll("SELECT * FROM mapnodes WHERE map = $checkbg"); //pobranie wszystkich wezlow wraz ze wspolrzednymi
$color = imagecolorallocate($im, 0, 255, 0);
if($CONFIG['nodesmap']['font_color'])
        {
        $col = $CONFIG['nodesmap']['font_color'];
        $col = explode(', ', $col);
        $textcolor = imagecolorallocate($im, $col[0], $col[1], $col[2]);
        }
else
        {
        $textcolor = imagecolorallocate($im, 0, 0, 255);
        }
if($CONFIG['nodesmap'])
        {
        if($CONFIG['nodesmap']['thickness'])
                {
                imagesetthickness($im, $CONFIG['nodesmap']['thickness']);
                }
        else
                {
                imagesetthickness($im, 3);
                }
        }
for($ct = 0; $ct <= count($dupa); $ct++)
        {
        $x1 = $dupa[$ct]['x'];
        $y1 = $dupa[$ct]['y'];
        $nod = $dupa[$ct]['number'];
	IF($nod)
		{
	        $location = $DB->GetOne("SELECT location FROM netdevices WHERE id = $nod"); // lokalizacja wezla
		$dev_existance = $DB->GetOne("SELECT id FROM netdevices WHERE id = $nod");
		$drawmap = $DB->GetOne("SELECT map FROM mapnodes WHERE map = $checkbg AND number = $nod");
		$nm = $DB->GetOne("SELECT name FROM netdevices WHERE id = $nod");
		if($dev_existance && $drawmap)
			{			
			$x2 = $x1 + 5;
			$y2 = $y1 + 5;
			$y3 = $y1 - 5;
			imagefilledrectangle($im, $x1-5, $y1-5, $x2, $y2, $color);
			if($CONFIG['nodesmap']['font'] && $CONFIG['nodesmap']['font_size'])
				{
                                $fn = $CONFIG['nodesmap']['font'];
                                $fn_size = $CONFIG['nodesmap']['font_size'];
                                $nm_text = imagettfbbox($fn_size, 0, $fn, $nm);
                                $height_nm = $nm_text[7] - $nm_text[1];
                                $width_nm = $nm_text[2] - $nm_text[0];
                                $location_text = imagettfbbox($fn_size, 0, $fn, $location);
                                $width_location = $location_text[2] - $location_text[0];
                                imagettftext($im, $fn_size, 0, $x1 - ($width_nm / 2), $y3+10-$height_nm, $textcolor, $fn, $nm);
                                imagettftext($im, $fn_size, 0, $x1 - ($width_location / 2), $y3+10-$height_nm-$height_nm, $textcolor, $fn, $location);
				}
			else
				{
				imagestring($im, 4, $x1-5, $y3, $nm, $textcolor);
				imagestring($im, 4, $x1-5, $y3+12, $location, $textcolor);
				}
			}
		}
       	}
	imagejpeg($im, $save);
}

function place_node()
{
	global $DB;
	$x = str_replace('.jpg', '_x', $_GET['tlo']);
	$y = str_replace('.jpg', '_y', $_GET['tlo']);
	IF($_GET['tlo'] && $_GET['device'] && $x && $y && $_GET[$x] > 0 && $_GET[$y] > 0)
		{
		$dev = $_GET['device'];
		$bg = '"'.$_GET['tlo'].'"';	
		$map_name = str_replace('.jpg', '', $_GET['tlo']);
		IF(!$DB->GetOne("SELECT * FROM mapnodes WHERE number = $dev AND map = $bg"))
			{
			$DB->Execute('INSERT INTO mapnodes (number, map, x, y) VALUES (?, ?, ?, ?)',
			array($_GET['device'], $_GET['tlo'], $_GET[$x], $_GET[$y]));
			}
		ELSE
			{
			$DB->Execute("UPDATE mapnodes SET x = ?, y = ? WHERE number = ? AND map = $bg", array($_GET[$x], $_GET[$y], $_GET['device']));
			}
		}
}

$layout['pagetitle'] = trans('Add/Modify Map');
background_find();
$deviceslist = $DB->GetAll('SELECT id, name, location FROM netdevices ORDER BY name ASC');
$device = $_GET['device'];
if($_GET['tlo'] &&  $_GET['device'] && isset($_GET['delete']))
	{
	$db_map = '"'.$_GET['tlo'].'"';
	$query = 'DELETE FROM mapnodes WHERE map = '.$db_map.' AND number = '.$_GET['device'];
	$DB->Execute($query);
	}
if($_GET["tlo"])
        {
	$rm = "/bin/rm";
        $name = str_replace('.jpg', '', $_GET["tlo"]); // ustawia wartosc select na ostatnia wybrana mape
	place_node();
        $tlo = 'http://'.$_SERVER['SERVER_ADDR'].':'.$_SERVER['SERVER_PORT'].$_SERVER['SCRIPT_NAME'].'/img/map/'.$_GET["tlo"]; //URL obrazka, part1
        $tlo = str_replace('index.php/', '', $tlo); // URL do obrazka, part2
	$file_dir = str_replace('index.php', 'img/map/', $_SERVER['SCRIPT_FILENAME']); // /var/www/lms/img/map
	$background_file_backup = str_replace('.jpg', '.jpg.bak', $_GET['tlo']); //*.jpg.bak
	IF(!file_exists($file_dir.$background_file_backup)) //sprawdz i zrob kopie pliku, jesli jej nie ma
		{
		exec($cp.' '.$file_dir.$_GET['tlo'].' '.$file_dir.$background_file_backup);
		}
	$plain_map = $file_dir.$background_file_backup; //plik do wczytania
	foreach(new DirectoryIterator(getcwd().'/img/map/') as $file)
		{
		IF(!$file->isDot())
			{
			IF(preg_match('/^.+timestamp_[0-9]+\.(jpg|JPG)$/D', $file))
				{
				//$pliki[] = $plik->getFilename();
				$to_remove = str_replace('index.php', 'img/map/', $_SERVER['SCRIPT_FILENAME']);
				exec($rm.' '.$to_remove.$file->getFilename());
				}
			}
		}
	$save = getcwd().'/img/map/'.$_GET['tlo'];
	$save = str_replace('.jpg', '_timestamp_'.time().'.jpg', $save);
	draw_nodes($plain_map, $save);
	$svfile = preg_replace('/.+\/img\/map\//', '', $save);
        if($_SERVER['SERVER_PORT'] == 443 || $_SERVER['HTTPS'])
        {
         $save2 = 'https://'.$_SERVER['SERVER_ADDR'].':'.$_SERVER['SERVER_PORT'].str_replace('index.php', 'img/map/', $_SERVER['SCRIPT_NAME']).$svfile;
        }
        else
        {
         $save2 = 'http://'.$_SERVER['SERVER_ADDR'].':'.$_SERVER['SERVER_PORT'].str_replace('index.php', 'img/map/', $_SERVER['SCRIPT_NAME']).$svfile;
        }
        $SMARTY->assign('tlo', $save2);
        $SMARTY->assign('name', $name);
        }
$bground = $_GET['tlo'];
$SMARTY->assign('bground', $bground);
$SMARTY->assign('pliki', $pliki);
$SMARTY->assign('deviceslist', $deviceslist);
$SMARTY->assign('device', $device);
$SMARTY->display('netdevmapmodify.html');
?>
