<?php

/*
 * LMS version 1.11.3 Quetesh
 *
 *  (C) Copyright 2001-2008 LMS Developers
 *
 *  Please, see the doc/AUTHORS for more information about authors!
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License Version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
 *  USA.
 *
 */
global $DB;
global $CONFIG;
global $t;
global $conf_last_online;

function background_find()
{
global $pliki;
foreach(new DirectoryIterator(getcwd().'/img/map/') as $plik)
        {
        IF(!$plik->isDot())
                {
		IF(preg_match('/^.+\.(jpg|JPG)$/D', $plik) && !preg_match('/^.+(timestamp).+$/D', $plik))
                $pliki[] = $plik->getFilename();
                }
        }

}


function draw_nodes($imgname, $save) //rysowanie wezlow na mapie
{
global $DB;
global $info;
global $CONFIG;
global $lastonline;
global $ela;
$checkbg = '"'.$_GET['tlo'].'"';
$im = @imagecreatefromjpeg($imgname);
if(!$im)
        {
        echo "Unable to open an image!";
        }
$allnodes = $DB->GetAll("SELECT * FROM mapnodes WHERE map = $checkbg"); //pobranie wszystkich wezlow wraz ze wspolrzednymi
$color = imagecolorallocate($im, 0, 255, 0);
$color2 = imagecolorallocate($im, 255, 0, 0);
$color3 = imagecolorallocate($im, 0, 0, 255);
if($CONFIG['nodesmap']['font_color'])
	{
	$col = $CONFIG['nodesmap']['font_color'];
	$col = explode(', ', $col);
	$textcolor = imagecolorallocate($im, $col[0], $col[1], $col[2]);
	}
else
	{
	$textcolor = imagecolorallocate($im, 0, 0, 255);
	}
for($ct = 0; $ct <= count($allnodes); $ct++) // dla kazdego wezla na mapie, np id = 8
	{
        $x1 = $allnodes[$ct]['x'];
        $y1 = $allnodes[$ct]['y'];
        $nod = $allnodes[$ct]['number'];
        IF($nod) // jesli prawidlowo zostal pobrany nr wezla
                {
		$nodname = $DB->GetOne("SELECT name FROM netdevices WHERE id = $nod");
		$counthosts = $DB->GetAll("SELECT id FROM nodes WHERE netdev = $nod");
                $location = $DB->GetOne("SELECT location FROM netdevices WHERE id = $nod"); // lokalizacja wezla
		$name = $DB->GetOne("SELECT name FROM netdevices WHERE id = $nod"); //nazwa wezla
                $dev_existance = $DB->GetOne("SELECT id FROM netdevices WHERE id = $nod"); // pobierz, jesli istnieje wezel
                $drawmap = $DB->GetOne("SELECT map FROM mapnodes WHERE map = $checkbg AND number = $nod"); //pobierz tlo mapy dla wezla
		$nodesactivity = $DB->GetAll("SELECT id, name, lastonline FROM nodes WHERE netdev = $nod");
                if($dev_existance && $drawmap)
                        {
                        $x2 = $x1 + 5;
                        $y2 = $y1 + 5;
                        $y3 = $y1 - 5;
			if($CONFIG['phpui'])
				{
				if($CONFIG['nodesmap']['thickness'])
					{
					imagesetthickness($im, $CONFIG['nodesmap']['thickness']);
					}
				else
					{
					imagesetthickness($im, 3);
					}

				$conf_last_online = $CONFIG['phpui']['lastonline_limit'];
				$to_check = $DB->GetAll("SELECT id, name, lastonline FROM nodes WHERE netdev = $nod AND lastonline > 0 ORDER BY lastonline DESC");
				if($to_check)
					{
					for($nodeschk = 0; $nodeschk <= count($to_check); $nodeschk++)
					        {
					        $current =  $to_check[$nodeschk]['lastonline'];
					        $t = time();
						$a = $t - $current;
						if($current)
							{
					        	if(($t - $current) < $conf_last_online)
								{								
								$asdf = $to_check[$nodeschk]['name'];
								$ela[$asdf] = 1;                                                	        
								}
							}
					        }
					$lastonline[$ct]['online'] = count($ela);
					if(count($ela) >= 1)
						{
						$x1 = $x1 - 5;
						$y1 = $y1 - 5;
						imagefilledrectangle($im, $x1, $y1, $x2, $y2, $color);
						}
					if(count($ela) < 1)
						{
						$x1 = $x1 - 5;
						$y1 = $y1 - 5;
						imagefilledrectangle($im, $x1, $y1, $x2, $y2, $color2);
						}
					unset($ela);
					}
				else
					{
					$x1 = $x1 - 5;
					$y1 = $y1 - 5;
                                        imagefilledrectangle($im, $x1, $y1, $x2, $y2, $color3);
                                        }
				}
                        else
                                {
                                echo 'Could not parse lms.ini file! Try to set lastonline_limit manually.';
                                }
			$hostsall = count($counthosts);
			$hostsonline = $lastonline[$ct]['online'];
			if(!$hostsonline)
				{
				$hostsonline = 0;
				}
			$hostsoffline = $hostsall - $hostsonline;
			$all_len = strlen($hostsall);
			$on_len = strlen($hostsonline);
			$off_len = strlen($hostsoffline);
			$conncolor = imagecolorallocate($im, 0, 0, 0);
			if($CONFIG['nodesmap']['font'] && $CONFIG['nodesmap']['font_size'])
				{
				$fn = $CONFIG['nodesmap']['font'];
				$fn_size = $CONFIG['nodesmap']['font_size'];
				$txt_two = imagettfbbox($fn_size, 0, $fn, $location);
				$width_two = $txt_two[2] - $txt_two[0];
				$height_two = $txt_two[7] - $txt_two[1];
				imagettftext($im, $fn_size, 0, ($x1 + 5)-($width_two / 2), $y1+10-$height_two, $textcolor, $fn, $location);
				$slash = imagettfbbox($fn_size, 0, $fn, ' / ');
				$slash_width = $slash[2] - $slash[0];
				$txt_three = imagettfbbox($fn_size, 0, $fn, $hostsoffline);
				$width_three = $txt_three[2] - $txt_three[0];
				$height_three = $txt_three[7] - $txt_three[1];
				$txt_four = imagettfbbox($fn_size, 0, $fn, $hostsonline);
				$width_four = $txt_four[2] - $txt_four[0];
				$txt_five = imagettfbbox($fn_size, 0, $fn, $hostsall);
				$width_five = $txt_five[2] - $txt_five[0];
				$width_all = $width_three + $slash_width + $width_four + $slash_width + $width_five;
				$center = ($x1 + 5) - ($width_all / 2);
				imagettftext($im, $fn_size, 0, $center - ($width_three / 2), $y1+($y2-$y1)-$height_two-$height_three, $color2, $fn, $hostsoffline);
				imagettftext($im, $fn_size, 0, $center - ($width_three / 2) + $width_three, $y1+($y2-$y1)-$height_two-$height_three, $conncolor, $fn, ' / ');
				imagettftext($im, $fn_size, 0, $center - ($width_three / 2) + $width_three + $slash_width, $y1+($y2-$y1)-$height_two-$height_three, $color, $fn, $hostsonline);
				imagettftext($im, $fn_size, 0, $center - ($width_three / 2) + $width_three + $slash_width + $width_four, $y1+($y2-$y1)-$height_two-$height_three, $conncolor, $fn, ' / ');
				imagettftext($im, $fn_size, 0, $center - ($width_three / 2) + $width_three + $slash_width + $width_four + $slash_width, $y1+($y2-$y1)-$height_two-$height_three, $conncolor, $fn, $hostsall);
				}
			else
				{
				echo 'WARNING! Could not get font attributes from lms.ini, drawing in the simplest way.';
				imagestring($im, 4, $x1, $y3+12, $name, $textcolor);
				imagestring($im, 4, $x1, $y3+22, $location, $textcolor);
				imagestring($im, 4, $x1, $y3+35, $hostsoffline, $color2);
				imagestring($im, 4, $x1+($off_len * 5)+3, $y3+35, '/', $conncolor);
				imagestring($im, 4, $x1+($off_len * 5)+10, $y3+35, $hostsonline, $color);
				imagestring($im, 4, $x1+($off_len * 5)+10+($on_len * 5)+3, $y3+35, '/', $conncolor);
				imagestring($im, 4, $x1+($off_len * 5)+10+($on_len * 5)+10, $y3+35, $hostsall, $conncolor);
				}
			$connections = $DB->GetAll("SELECT * FROM netlinks WHERE src = $nod");
			$conncolor = imagecolorallocate($im, 0, 0, 0);
			for($all = 0; $all <= count($connections); $all++)
				{
				$dest = $connections[$all]['dst'];
				$typ = $connections[$all]['type'];
				IF($dest && isset($_GET['conns']))
					{
					$queryx = 'SELECT x FROM mapnodes WHERE number ='.' '.$dest.' AND map = '.$checkbg;
					$queryy = 'SELECT y FROM mapnodes WHERE number ='.' '.$dest.' AND map = '.$checkbg;
					$xloc = $DB->GetOne($queryx);
					$yloc = $DB->GetOne($queryy);
					if($x1 != 0 && $x2 != 0 && $y1 != 0 && $y2 != 0 && $xloc != 0 && $yloc != 0){				
					//imageline($im, (($x1+$x2)/2), (($y1+$y2)/2), ($xloc+($xloc+10))/2, ($yloc+($yloc+10))/2, $conncolor);
					imageline($im, ((($x1-5)+($x2+5))/2), ((($y1-5)+($y2+5))/2), $xloc, $yloc, $conncolor);
					}
				}
				}			
                        }
                }
        }
        imagejpeg($im, $save);
}

function imagemap()
{

}

$layout['pagetitle'] = trans('Network Map New');
$rm = "/bin/rm -f";
background_find();
$bg = str_replace('index.php', 'img/map/done/', $_SERVER['SCRIPT_FILENAME']).$_GET['tlo'];
$base = str_replace('index.php', 'img/map/', $_SERVER['SCRIPT_FILENAME']).$_GET['tlo'];
foreach(new DirectoryIterator(getcwd().'/img/map/done/') as $file)
	{
	IF(!$file->isDot())
		{
		IF(preg_match('/^.+timestamp_[0-9]+\.(jpg|JPG)$/D', $file))
			{
				$to_remove = str_replace('index.php', 'img/map/done/', $_SERVER['SCRIPT_FILENAME']);
				exec($rm.' '.$to_remove.$file->getFilename());
			}
		}
	}
$SMARTY->assign('pliki', $pliki);
$lnks = $DB->GetAll('SELECT id, src, dst FROM netlinks ORDER BY id ASC');
for($bb = 0; $bb < count($lnks); $bb++)
	{
	$src = $lnks[$bb]['src'];
	$dst = $lnks[$bb]['dst'];
	$id = $lnks[$bb]['id'];
	$query_src = 'SELECT name FROM netdevices WHERE id ='.' '.$src;
	$query_dst = 'SELECT name FROM netdevices WHERE id ='.' '.$dst;
	$lnks[$bb] = array("id" => $id, "srcid" => $src, "dstid" => $dst, "src" => $DB->GetOne($query_src), "dst" => $DB->GetOne($query_dst));
	}
$SMARTY->assign('get', $_GET);
IF($_GET['tlo'])
	{
	$bg_query = '"'.$_GET['tlo'].'"';
	$nodesall = $DB->GetAll("SELECT * FROM mapnodes WHERE map = $bg_query");
	for($cc = 0; $cc <= count($nodesall); $cc++)
		{
		$x = $nodesall[$cc]['x'];
		$y = $nodesall[$cc]['y'];
		$nom = $nodesall[$cc]['number'];
		if($nom)
			{
			$nm = $DB->GetOne("SELECT name FROM netdevices WHERE id = $nom");
			$latestonline = $DB->GetOne("SELECT lastonline FROM nodes WHERE netdev = $nom ORDER BY lastonline DESC LIMIT 1");
			if($latestonline != 0){			
			$latestonline = date("d-m-y H:i:s", $latestonline);}
			else{
			$latestonline = "Nigdy";}			
			$nodes_imgmap[$cc] = array(
			"id" => $nom,
			"name" => $nm,
			"lastonline" => $latestonline,
			"x1" => $nodesall[$cc]['x'],
			"y1" => $nodesall[$cc]['y'],
			"x2" => $nodesall[$cc]['x'] + 10,
			"y2" => $nodesall[$cc]['y'] + 10);
			}
		}
	$save = str_replace('.jpg', '_timestamp_'.time().'.jpg', $bg);
	draw_nodes($base, $save);
	$tlo = preg_replace('/.+\/img/', 'img', $save);
	$SMARTY->assign('list', $lastonline);
	$SMARTY->assign('tlo', $tlo);
	$SMARTY->assign('allnodes', $nodes_imgmap);
	}

if($_GET['conns'] == 1 || !$_GET['conns'] && $_GET['m'] == 'netdevmapnew' && !$_GET['tlo'] || $_GET['conns'] == on)
	{	
	$conns = 1;
	$SMARTY->assign('conns', $conns);
	}
$bground = $_GET['tlo'];
$SMARTY->assign('bground', $bground);
$SMARTY->display('netdevmapnew.html');
?>
